#include <stdio.h>
#include <errno.h>
#include <f2c.h>

int dgeev_(char *jobvl, char *jobvr, integer *n, doublereal * a,
           integer *lda, doublereal *wr, doublereal *wi, doublereal *vl,
           integer *ldvl, doublereal *vr, integer *ldvr, doublereal *work,
           integer *lwork, integer *info);

main(int argc, char *argv[])
{
   char           *jobvl = "N\0";
   char           *jobvr = "N\0";
   integer         n = 4;
   doublereal **A;
   doublereal  *Pointer;
   integer         lda = 4;
   doublereal   Eigenvalue_real[5];
   doublereal   Eigenvalue_imag[5];
   doublereal   vl[2];
   integer         ldvl = 1;
   doublereal   vr[2];
   integer         ldvr = 1;
   doublereal   work[137];
   integer         lwork = 136;
   doublereal      rwork[9];
   integer         info;

   int             i;
   int             Index;

   if ((A = (doublereal **) malloc(sizeof(doublereal *) * 4)) == NULL)
   {
      perror(argv[0]);
      exit(1);
   }

   if ((Pointer = (doublereal *) malloc(sizeof(doublereal) * 4 * 4 + 1))
       == NULL)
   {
      perror(argv[0]);
      exit(1);
   }

   for (i = 0, Index = 1; i < 4; i++, Index += 4)
   {
      A[i] = &(Pointer[Index]);
   }

   A[0][0] = 2.0;
   A[1][0] = 1.0;
   A[2][0] = 0.0;
   A[3][0] = 0.0;

   A[0][1] = 1.0;
   A[1][1] = 2.0;
   A[2][1] = 1.0;
   A[3][1] = 0.0;

   A[0][2] = 0.0;
   A[1][2] = 1.0;
   A[2][2] = 2.0;
   A[3][2] = 1.0;

   A[0][3] = 0.0;
   A[1][3] = 0.0;
   A[2][3] = 1.0;
   A[3][3] = 2.0;

   dgeev_(jobvl, jobvr, &n, &Pointer[1], &lda, &Eigenvalue_real[1],
          &Eigenvalue_imag[1],
          &vl[1], &ldvl, &vr[1], &ldvr, &work[1], &lwork, &info);

   printf("info = %d work[0] = %g\n", info, work[0]);
   for (i = 1; i < 5; i++)
      printf("Eigenvalue[%d] = (%g, %g)\n", i, Eigenvalue_real[i],
             Eigenvalue_imag[i]);
}

